<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { associationsApi, sponsorApi, websiteApi } from '$lib/requests/requests';
	import { slide } from 'svelte/transition';
	import { quintOut } from 'svelte/easing';
	import type { Association } from '$lib/api';
	import { api } from '$lib/config';
	import ReconnectingWebSocket from 'reconnecting-websocket';
	// This URI should work : http://localhost:5173/sponsors-loop

	let selectedSponsor: Sponsor | null;

	let sponsors: Sponsor[];
	let slideshowInterval: number;
	let slideInterval: number;
	let sponsorsex: Sponsor[] = [
		{
			description: 'test',
			id: 0,
			image_file:
				'https://fastly.picsum.photos/id/970/200/300.jpg?hmac=8mPwdPFtAKcn0NQrEIClW3IlOWsKgskAikm_8YQj-qM',
			link: 'lol',
			name: 'test'
		},
		{
			description: 'oui',
			id: 1,
			image_file:
				'https://fastly.picsum.photos/id/1019/200/300.jpg?hmac=HLUPqgTMOzQ6-GDkgZZ3NXQqJyl5m6iX_MXvS3Xqt3Q',
			link: 'lol',
			name: 'oui'
		}
	];
	let i: number = 0;

	onMount(async () => {
		try {
			let respSponsor = await sponsorApi().getSponsorsSponsorsGet();
			let respAssoc = await associationsApi().getAssociationsAssociationsGet();
			// let respEvent = await websiteApi().getLogoWebsiteLogoGet();
			let respEvent = { data: [] };
			sponsors = respSponsor.data;
			sponsors = sponsors.concat(respAssoc.data);
			sponsors = sponsors.concat(respEvent.data);
			console.log(sponsors);

			slideshow();
			slideshowInterval = setInterval(() => slideshow(), 60000);
		} catch {
			// Redirect to 404
			// window.location.href = '/404';
		}
	});

	onDestroy(() => {
		clearInterval(slideshowInterval);
		clearInterval(slideInterval);
	});

	function slideshow() {
		if (slideInterval) {
			clearInterval(slideInterval);
			slideInterval = 0;
		}
		slideInterval = setInterval(() => showSlide(), 3000);
	}

	function showSlide() {
		selectedSponsor = sponsors[i];
		if (i >= sponsors.length) {
			selectedSponsor = null;
			(i = 0), clearInterval(slideInterval);
			slideInterval = 0;
		} else {
			i++;
		}
	}
</script>

<div>
	{#if sponsors}
		<div class="rounded-lg p-4 flex flex-col">
			{#each sponsors as sponsor}
				{#if sponsor === selectedSponsor}
					<div
						in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
						out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
						class="item"
					>
						<div 
							style="background-image: url({api() + sponsor?.image_file});"
							class="sponsor-image"
						></div>
					</div>
				{/if}
			{/each}
		</div>
	{/if}
</div>

<style>
	.sponsor-image {
		width: 250px; 
		height: 167px; 
		background-size: contain;
		background-position: center;
		background-repeat: no-repeat;
	}
</style>
